%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%maximize
%logexp_sum(spline_sum(matrix_parameters_vars, matrix_data))
%constraint: <= 10
%linear(matrix_linear)
%
%calculate
%Point: point_problem_1
%logexp_sum(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%logistic(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%
%Input variables:
%
%Inputs                         PSG Type    PSG Object                Location in Problem Statement                                                     Class
%matrix_data_benchmark          bench       matrix_data               logexp_sum(spline_sum(matrix_parameters_vars, matrix_data))                       double
%                                                                     logexp_sum(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%                                                                     logistic(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%matrix_data_data               data        matrix_data               logexp_sum(spline_sum(matrix_parameters_vars, matrix_data))                       double
%                                                                     logexp_sum(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%                                                                     logistic(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%matrix_data_vars               vars        matrix_data               logexp_sum(spline_sum(matrix_parameters_vars, matrix_data))                       cell
%                                                                     logexp_sum(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%                                                                     logistic(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%matrix_linear_data             data        matrix_linear             linear(matrix_linear)                                                             double
%matrix_linear_vars             vars        matrix_linear             linear(matrix_linear)                                                             cell
%matrix_parameters_vars_data    data        matrix_parameters_vars    logexp_sum(spline_sum(matrix_parameters_vars, matrix_data))                       double
%                                                                     logexp_sum(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%                                                                     logistic(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%matrix_parameters_vars_vars    vars        matrix_parameters_vars    logexp_sum(spline_sum(matrix_parameters_vars, matrix_data))                       cell
%                                                                     logexp_sum(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%                                                                     logistic(spline_sum(matrix_parameters_vars, matrix_data, matrix_data_knots))
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\All\Spline Regression\problem_4_logexp_sum_of_splines_knots_calculate\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine:

[solution_str,outargstruc_arr] = Optimization_subroutine(matrix_data_benchmark,matrix_data_data,matrix_data_vars,matrix_linear_data,matrix_linear_vars,matrix_parameters_vars_data,matrix_parameters_vars_vars);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
